"use strict";

exports.__esModule = true;
exports.default = undefined;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDraggable = require("react-draggable");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Draggable(_ref) {
  var cancel = _ref.cancel,
      children = _ref.children,
      isDraggable = _ref.isDraggable,
      isResizable = _ref.isResizable,
      handle = _ref.handle,
      _onDrag = _ref.onDrag;

  if (isDraggable) {
    return _react2.default.createElement(
      _reactDraggable.DraggableCore,
      {
        onStart: function onStart(e, data) {
          return _onDrag(e, data, "onDragStart");
        },
        onDrag: function onDrag(e, data) {
          return _onDrag(e, data, "onDrag");
        },
        onStop: function onStop(e, data) {
          return _onDrag(e, data, "onDragStop");
        },
        handle: handle,
        cancel: ".react-resizable-handle" + (cancel.length ? "," + cancel : "")
      },
      isResizable ? children : children.props.children
    );
  }

  return children;
}

exports.default = Draggable;
Draggable.propTypes = {
  cancel: _propTypes2.default.string.isRequired,
  children: _propTypes2.default.node.isRequired,
  isDraggable: _propTypes2.default.bool.isRequired,
  handle: _propTypes2.default.string.isRequired,
  onDrag: _propTypes2.default.func.isRequired
};