"use strict";

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactResizable = require("react-resizable");

var _propTypes3 = require("./propTypes");

var propTypes = _interopRequireWildcard(_propTypes3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function Resizable(_ref) {
  var calcPosition = _ref.calcPosition,
      children = _ref.children,
      cols = _ref.cols,
      x = _ref.x,
      minW = _ref.minW,
      minH = _ref.minH,
      maxW = _ref.maxW,
      maxH = _ref.maxH,
      isResizable = _ref.isResizable,
      _onResize = _ref.onResize,
      position = _ref.position,
      resizableProps = _ref.resizableProps,
      rest = _objectWithoutProperties(_ref, ["calcPosition", "children", "cols", "x", "minW", "minH", "maxW", "maxH", "isResizable", "onResize", "position", "resizableProps"]);

  if (isResizable) {
    // This is the max possible width - doesn't go to infinity because of the width of the window
    var maxWidth = calcPosition(0, 0, cols - x, 0).width;

    // Calculate min/max constraints using our min & maxes
    var mins = calcPosition(0, 0, minW, minH);
    var maxes = calcPosition(0, 0, maxW, maxH);
    var minConstraints = [mins.width, mins.height];
    var maxConstraints = [Math.min(maxes.width, maxWidth), Math.min(maxes.height, Infinity)];

    return _react2.default.createElement(
      _reactResizable.Resizable,
      _extends({
        width: position.width,
        height: position.height,
        minConstraints: minConstraints,
        maxConstraints: maxConstraints,
        onResizeStop: function onResizeStop(e, data) {
          return _onResize(e, data, "onResizeStop");
        },
        onResizeStart: function onResizeStart(e, data) {
          return _onResize(e, data, "onResizeStart");
        },
        onResize: function onResize(e, data) {
          return _onResize(e, data, "onResize");
        }
      }, resizableProps, rest),
      children
    );
  }

  return children;
}

exports.default = Resizable;
Resizable.propTypes = {
  calcPosition: _propTypes2.default.func,
  children: _propTypes2.default.node.isRequired,
  cols: _propTypes2.default.number.isRequired,
  x: _propTypes2.default.number.isRequired,
  minW: propTypes.minW,
  maxW: propTypes.maxW,
  minH: propTypes.minH,
  maxH: propTypes.maxH,
  isResizable: _propTypes2.default.bool.isRequired,
  onResize: _propTypes2.default.func.isRequired,
  position: _propTypes2.default.shape({
    width: _propTypes2.default.number,
    height: _propTypes2.default.number
  }).isRequired,
  resizableProps: _propTypes2.default.object.isRequired
};